#jinja2:trim_blocks:False
global
  log 127.0.0.1 local0
  log 127.0.0.1 local1 notice
  maxconn 4096
  #ssl-default-bind-ciphers kEECDH+aRSA+AES:kRSA+AES:+AES256:RC4-SHA:!kEDH:!LOW:!EXP:!MD5:!aNULL:!eNULL
  tune.ssl.default-dh-param 2048 # not sure
  ssl-default-bind-ciphers ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES256-SHA384:ECDHE-RSA-AES256-SHA384:ECDHE-ECDSA-AES128-SHA256:ECDHE-RSA-AES128-SHA256:!kEDH:!LOW:!EXP:!MD5:!aNULL:!eNULL
  ssl-default-bind-options ssl-min-ver TLSv1.2 no-tls-tickets

defaults
  log	global
  mode	http
  option	httplog
  option	dontlognull
  timeout connect 5s
  timeout client 1800s
  timeout client-fin 50s
  timeout server 1800s
  timeout tunnel 1h

frontend stats
  bind *:{{haproxy_stats_port}}
  mode http
  stats enable
  stats hide-version
  stats realm Haproxy\ Statistics
  stats uri /haproxy_stats
  stats auth {{ haproxy_user }}:{{ haproxy_passwd }}
  stats refresh 10s
  stats admin if LOCALHOST


#############################
#  nexus
#############################

frontend front-nexus-http-proxy
  bind *:{{ ha_proxy_port }}
  mode http
  option httplog
  acl url_api path_beg /v2
  acl url_conan_search path_beg /repository/conan-internal/v1/conans/search
  use_backend back-nexus-api-backend if url_api
  use_backend back-nexus-conan-backend if url_conan_search
  default_backend back-nexus-default-backend
  timeout client 1800s
  timeout client-fin 50s

frontend front-nexus-quarantine-http-proxy
  bind *:{{ ha_quarantine_proxy_port }}
  mode http
  option httplog
  acl url_api path_beg /v2
  use_backend back-nexus-quarantine-api-backend if url_api
  default_backend back-nexus-default-backend
  timeout client 1800s
  timeout client-fin 50s

backend back-nexus-default-backend
  mode http
  option http-server-close
  option dontlognull
  balance roundrobin
  {%- for item in groups['nexus'] %}
  server {{ item }} {{hostvars[item]["ansible_host"]}}:{{ nexus_http_proxy_port }} check
  {%- endfor %}
  timeout connect 10s
  timeout server 1800s

backend back-nexus-api-backend
  mode http
  option http-server-close
  option dontlognull
  balance roundrobin
  {%- for item in groups['nexus'] %}
  server {{ item }} {{hostvars[item]["ansible_host"]}}:{{ nexus_api_proxy_port }} check
  {%- endfor %}
  timeout connect 10s
  timeout server 1800s

backend back-nexus-conan-backend
  mode http
  option http-server-close
  option dontlognull
  balance roundrobin
  {%- for item in groups['nexus'] %}
  server {{ item }} {{hostvars[item]["ansible_host"]}}:{{ nexus_conan_search_proxy_port }} check
  {%- endfor %}
  timeout connect 10s
  timeout server 1800s

backend back-nexus-quarantine-api-backend
  mode http
  option http-server-close
  option dontlognull
  balance roundrobin
  {%- for item in groups['nexus'] %}
  server {{ item }} {{hostvars[item]["ansible_host"]}}:{{ nexus_quarantine_api_proxy_port }} check
  {%- endfor %}
  timeout connect 10s
  timeout server 1800s
